Author Topic: Extend curve  (Read 561 times)

0 Members and 1 Guest are viewing this topic.

Offline fixo

  • Full Member
  • ***
  • Posts: 135
  • Karma: +4/-0
  • Gender: Male
    • prefered language: C
    • Prog expertise: Good
    • View Profile
Extend curve
« on: June 22, 2012, 10:34:19 PM »
Code: [Select]
        [CommandMethod("ExtendCurve", "exc", CommandFlags.Modal)]
        static public void testExtendCurve()
        {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

            Editor ed = doc.Editor;

            Database db = doc.Database;

            try
            {
                using (Transaction tr = db.TransactionManager.StartTransaction())
                {
                    PromptEntityOptions peo = new PromptEntityOptions("\nSelect boundary edge... >>");

                    PromptEntityResult exres;
                    exres = ed.GetEntity(peo);
                    if (exres.Status != PromptStatus.OK)
                        return;

                    Entity exent = (Entity)tr.GetObject(exres.ObjectId, OpenMode.ForRead);
                    if (exent == null)
                        return;
                    Curve excur = exent as Curve;
                    peo = new PromptEntityOptions("\nSelect curve to extend >>");

                    PromptEntityResult res;
                    res = ed.GetEntity(peo);
                    if (res.Status != PromptStatus.OK)
                        return;

                    Entity ent = (Entity)tr.GetObject(res.ObjectId, OpenMode.ForRead);
                    if (ent == null)
                        return;

                    if (ent.GetRXClass().DxfName == "SPLINE")
                    {
                        ed.WriteMessage("\nCould not extend the spline");
                        return;
                    }
                    Curve cur = ent as Curve;
                    Point3dCollection pts = new Point3dCollection();
                    cur.IntersectWith(excur, Intersect.ExtendThis, pts, 0, 0);
                    if (pts.Count == 0)
                    {
                       ed.WriteMessage("\nCurves aren't intersects each other");
                        return;
                    }

                    Point3d pt = pts[0];// ought be to correct this point with circle and closed polyline
                   
                    if (!cur.IsWriteEnabled)
                        cur.UpgradeOpen();

                    Point3d pp = cur.GetClosestPointTo(res.PickedPoint, false);

                    bool sofar = false;

                    if (pp.DistanceTo(pt) < pt.DistanceTo(cur.EndPoint))
                        sofar = true;

                    if (sofar)
                    {
                        cur.Extend(true, pt);
                    }
                    else
                    {
                        cur.Extend(false, pt);
                    }
                   
                    tr.Commit();
                }
            }
            catch (System.Exception ex)
            {
                ed.WriteMessage(ex.Message );
            }

        }

~'J'~